#include	"mview.h"
#include	<jctype.h>

char	*jstrncpy(char *dest, char *src, int num);
void	extract_name(char *dest, char *src, int num);


/* src  dest  num oCgʂBShift_JISl */
char *
jstrncpy(dest, src, num)
char	*dest;
char	*src;
int	num;
{
	char	*p = src, *w = dest;

	while (--num >= 0) {
		if (iskanji(*p)) {
			if (--num < 0)	break;
			*w++ = *p++;
		}
		if (!*p)	break;
		*w++ = *p++;
	}
	*w = '\0';

	return dest;
}


/*	MIMEwb_̃AhX\L
		AhX (O)
		O <AhX>
		AhX
	3ނB𔻕ʂ dest ɖO擾B
	src ͔j󂳂̂ŒӁB */
void
extract_name(dest, str, num)
char	*dest;
char	*str;
int	num;
{
	unsigned char	*head, *tail, *p;

	for (head = (unsigned char*)str; *head && *head <= ' '; head++);
	p = head;

	while (*p) {
		if (*p == '(') {
			head = ++p;
			while (*p && *p != ')')	p++;
			break;
		} else if (*p ==  '\"') {
			head = ++p;
			while (*p && *p != '\"')	p++;
			break;
		} else if (*p == ',' || *p =='<') {
			if (p == head) {
				head = ++p;
			} else {
				break;
			}
		} else if (*p ==  '@') {
			*p = '\0';
		}
		if (iskanji(*p)) {
			p += 2;
		} else {
			p++;
		}
	}
	tail = p;
	while (head < tail && *(tail - 1) <= ' ')	tail--;
	*tail = '\0';

	/* O𒊏o */
	jstrncpy(dest, head, num);
}
