#include	"mview.h"
#include	<stdlib.h>
#include	<string.h>
#include	<unistd.h>
#define	__DOS_INLINE__
#include	<doslib.h>
#include	"mail.h"

static void	tini();
static void	FILEGET();
static int	allocnewmail();
static void	makemllist();
static void	MakeInf(MAILDATA *MailTemp);
static void MailTempInit(MAILDATA*, char*);
static int	SaveInf();

MAILDATA	*newmail;
MAILDATA	**newptr;
int	MailNew;
int	newmax = 256;
static char *Month[12]= {	"Jan", "Feb", "Mar", "Apr",
							"May", "Jun", "Jul", "Aug",
							"Sep", "Oct", "Nov", "Dec" };


static int	getft(char *file)
{
	int	fh, dostime = -1;

	fh = OPEN(file, 0);
	if (fh < 0) {
		fputs("t@CJ܂", stdout);
	} else {
		dostime = FILEDATE(fh, 0);
		CLOSE(fh);
		if (dostime == -1) {
			fputs("t@Cُł", stdout);
		}
	}

	return dostime;
}


static void	tini()
{
	if (MailNew)	SaveInf();	/* ۑ */
	if (newptr)	free(newptr);
	if (newmail)	free(newmail);
}


/* MLlist2.INFTAtOڐA */
static void
FILEGET()
{
	int	i, j, k = MailNew;
	MAILDATA	mailtemp;
	FILE	*fp;
	unsigned char	INFFile[128];

	MailNow = 0;					/* [ */

	strcpy(INFFile, MAILLIST);

	if (!(fp = fopen(INFFile, "rb"))) {	/* MAILLISTȂ */
		fputs("MLlist2.INF܂\n", stdout);
		return;
	}

	fread(&MailNow, 4, 1, fp);/* MAILLISTǂݍ */
	if (!MailNow) {			/* [ȂΖ߂ */
		fclose(fp);
		fputs("MLlist2.INF͋ł\n", stdout);
		return;
	}

	fputs("tOڐA\n", stdout);
	for (i = 0; k > 0 && i < MailNow; i++) {
		fread(&mailtemp, sizeof(MAILDATA), 1, fp);
		for (j = 0; j < MailNew; j++) {
			if (!strcmp(mailtemp.filename, newmail[j].filename)) {
				newmail[j].fileflag = mailtemp.fileflag;
				k--;
				break;
			}
		}
	}
	fclose(fp);
}

static int
allocnewmail()
{
	if (newmail)	free(newmail);
	newmail = malloc(sizeof(MAILDATA) * newmax);
	if (!newmail) {
		fputs("܂\n", stdout);
		return FALSE;
	}
	return TRUE;
}

static void
makemllist()
{
	int	FoundFile;
	int	endflag = FALSE;
	struct	FILBUF	files_buffer;	/* FILES(fBNg)p */

	while (!endflag) {
		MailNew = 0;
		if (!allocnewmail())	return;

		FoundFile = FILES(&files_buffer, "*.ML", 0x20);
		while (TRUE) {			/* A */
			if (FoundFile < 0) {
				endflag = TRUE;
				break;
			}
			if (MailNew >= newmax) {
				newmax *= 2;
				break;
			}
			if (strcmp(files_buffer.name, ".")
					&& strcmp(files_buffer.name, "..")) {
				strcpy(newmail[MailNew].filename, files_buffer.name);
				fputs(files_buffer.name, stdout);
				MakeInf(&(newmail[MailNew++]));
				fputc('\n', stdout);
			}
		 	FoundFile = NFILES(&files_buffer);
		}
	}
}

static void
MakeInf(MailTemp)
MAILDATA	*MailTemp;
{
	FILE	*fp;
	int	i;
	char	GetFlag,	/* wb_EH */
			*Temp, from[128], TempStr[1024];

	/* oOɏ */
	from[0] = '\0';
	MailTemp->title[0] = '\0';
	MailTemp->name[0] = '\0';
	MailTemp->year[0] = '\0';
	MailTemp->time[0] = '\0';
	MailTemp->fileflag = 0;

	if (SendFlag) {
		MailTempInit(MailTemp, MailTemp->filename);
	} else {
		MailTemp->year_v = 0;
		MailTemp->time_v = 0;
	}

	if (!(fp = fopen(MailTemp->filename, "rt"))) {
		fputs(" I[vł܂", stdout);
		return;
	}

	GetFlag = 0;

	/* 邾̃f[^Bswb_ĨTC */
	while (fgets822a(TempStr, sizeof(TempStr), fp)) {
		decode_mime(TempStr, TempStr);

		if (Temp = GetKeyword(TempStr, "SUBJECT:")) {
			/* ^Cg擾 */
			GetFlag++;
			strcpy(MailTemp->title, CutStr2(Temp, MSUBJECT_MAX));
			continue;
		}

		if (Temp = GetKeyword(TempStr, "FROM:")) {
			GetFlag++;		 	/* O擾 */
			extract_name(from, Temp, MNAME_MAX);
			continue;
		}

		 /* Return-Path擾(FromȂɑp) */
		if (*from == '\0' && (Temp = GetKeyword(TempStr, "RETURN-PATH:"))) {
			GetFlag++;
			extract_name(from, Temp, MNAME_MAX);
			continue;
		}

		if (*from == '\0' && (Temp = GetKeyword(TempStr, "TO:"))) {
			/* O擾 */
			GetFlag++;
			extract_name(from, Temp, MNAME_MAX);
			continue;
		}

		/* t̎擾 */
		if (Temp = GetKeyword(TempStr, "DATE:")) {
			int	date, year;
			char	*month, *time,
					*time0, *time1, *time2;

			GetFlag++;
			strcpy(TempStr, Temp);	/* Date: ̎𒊏o */

			/* jꍇ̓J}̌Ȃ̂ł炷 */
			if (Temp = strchr(TempStr, ',')) {
				Temp += 1;
			}else {
				Temp = TempStr;
			}

			/* g[NŊēo */
			date = atoi(strtok(Temp, " "));
			month = strtok(NULL, " ");
			year = atoi(strtok(NULL, " "));
			time = strtok(NULL, " ");
			time[8] = '\0';

			if (year < 100) {	/* QȂ␳ */
				if (year >= 70) {
					year += 1900;
				} else {
					year += 2000;
				}
			}

			for (i = 0; i < 12; i++) {
				if (!strcmp(month, Month[i]))	break;
			}
			i++;
			sprintf(MailTemp->year, "%4.4d-%2.2d-%2.2d", year, i, date);

			/* r̂߂̌vZ */
			MailTemp->year_v = year * 10000;
			MailTemp->year_v += i * 100;
			MailTemp->year_v += date;

			if (!strchr( time, ':')) {
				/* ΉĂȂł00:00:00ŕ] */
				MailTemp->time_v = 0;
				strcpy(MailTemp->time, "00:00:00");
			} else {
				strcpy(MailTemp->time, time);
				time0 = strtok(time, ":");
				time1 = strtok(NULL, ":");
				time2 = time + 6;
				MailTemp->time_v = atoi(time0) * 10000
									+ atoi(time1) * 100
									+ atoi(time2);
			}
			continue;
		} else if(strstr(TempStr, "boundary=")) {
			/* wb_ boundary= ΃NbvtOON */
			MailTemp->fileflag |= M_CLIP;
		}

	}
	fclose(fp);
	MailTemp->type = 1;
	strcpy(MailTemp->name, from);

	if (GetFlag < (2 - (SendFlag)? 1:0)) {
		/* 擾wb_eQȏȂ烁[ƂĔF߂B
			SendFlag΂Pŕs */
		fputs(" ̓[ƂĔFł܂", stdout);
		MailTemp->year_v = 0;
	}
}


static void
MailTempInit(MailTemp, filename)
MAILDATA	*MailTemp;
char	*filename;
{
	int	temp, i, j, k;

	/* Sendt@C̏ꍇADate:Ȃ̂ō쐬ZbgĂ */
	temp = getft(filename);
	i = (((temp >> 25) & 127) % 100) + 1980;
	j = (temp >> 21) & 15;
	k = (temp >> 16) & 31;

	sprintf(MailTemp->year, "%4.4d-%2.2d-%2.2d", i, j, k);

	/* r̂߂̌vZ */
	MailTemp->year_v = i * 10000 + j * 100 + k;

	i = (temp >> 11) & 31;
	j = (temp >> 5) & 63;
	k = temp & 31;
	k *= 2;
	sprintf(MailTemp->time, "%2.2d:%2.2d:%2.2d", i, j, k);

	MailTemp->time_v = i * 10000 + j * 100 + k;
}


/* INFZ[u */
static int
SaveInf()
{
	int	i, j;
	MAILDATA	**ptr = newptr;
	FILE	*fp;

	j = MailNew;
	for (i = 0; i < MailNew; i++) {
		if ((*ptr)->year_v)	break;
		ptr++;
		j--;
	}

	if (!j)	return FALSE;
	MailNew = j;

	if (!(fp = fopen(MAILLIST, "wb"))) {
		fputs("MLlist2.INF쐬ł܂\n", stdout);
		return FALSE;
	}

	fputs("MLlist2.INFۑ\n", stdout);
	fwrite(&MailNew, sizeof(int), 1, fp);
	for (i = 0; i < MailNew; i++) {
		fwrite(ptr[i], sizeof(MAILDATA), 1, fp);
	}
	fclose(fp);

	return TRUE;
}


int main()
{
	int	i;
	char	*tmp;

	if (!getcwd(CDir, 96))	return FALSE;

	tmp = strrchr(CDir, '\\');
	if (!tmp) {
		char	*p = CDir;
		while (*p) {
			if (*p == '/') {
				*p = '\\';
				tmp = p;
			}
			p++;
		}
	}
	strcpy(CDir, ++tmp);
	SendFlag = SendCheck(CDir);
	if (!SendFlag) {
		SendFlag = !strcmpi(CDir, "TRASH");
	}

	newmail = NULL;
	newptr = NULL;
	makemllist();	/* [擾 */
	if (!MailNew) {
		fputs("[܂\n", stdout);
		tini();
		return TRUE;
	}

	FILEGET();	/* tOڐA */

	newptr = malloc(sizeof(MAILDATA**) * MailNew);
	if (!newptr) {
		fputs("\[gp܂\n", stdout);
		newptr = NULL;
		tini();
		return FALSE;
	}

	fputs("\[g܂\n", stdout);
	for (i = 0; i < MailNew; i++) {
		newptr[i]= &(newmail[i]);
	}
	if (pqsort(newptr, MailNew) < 0) {
		fputs("\[gp܂\n", stdout);
		tini();
		return FALSE;
	}

	tini();
	fputs("܂\n", stdout);
	return TRUE;
}
